import { useState } from '#app'
import { Ref } from 'vue'
import start from '@/composables/engine/start'

interface EngineContext {
    isActive: Ref<boolean>
    shouldStop: Ref<boolean>
}

export interface useEngine {
    start(): void
    stop(): void
}

export default (): useEngine => {
    const context: EngineContext = {
        isActive: useState('engine__is-active', () => false),
        shouldStop: useState('engine__should-stop', () => false),
    }

    return {
        start: () => start.apply(context),
        stop: (): void => {
            if (context.isActive.value) {
                context.shouldStop.value = true
                console.log('shut down engine')
            }
        },
    }
}